<template>
    <div>
        <el-dialog v-model="dialogVisible" :close-on-click-modal="false" draggable width="1200px" height="500px">
            <el-card :body-style="cardBodyStyle">
                <el-form inline :model="query">
                    <el-form-item label="订单号" style="margin-bottom: 5px;">
                        <el-input v-model="query.purOrdNo" placeholder="请输入" style="width: 200px; margin-right: 10px;" clearable></el-input>
                    </el-form-item>
                    <el-form-item label="订单行号" style="margin-bottom: 5px;">
                        <el-input v-model="query.purOrdLn" placeholder="请输入" style="width: 200px; margin-right: 10px;" clearable></el-input>
                    </el-form-item>
                </el-form>
            </el-card>

            <el-card :body-style="cardBodyStyle">
                <el-button plain type="primary" @click="search">查询</el-button>
            </el-card>
            
            <el-card :body-style="cardBodyStyle">
                <el-table :data="tableData" border highlight-current-row>
                    <el-table-column v-for="(item, index) in column" :key="index" :prop="item.prop" :label="item.label"
                        header-align="center" align="center" show-overflow-tooltip :width="item.width"
                        :formatter="formatter">
                    </el-table-column>
                    <el-table-column label="操作" header-align="center" align="center" show-overflow-tooltip width="200px"
                        fixed="right">
                        <template #default="scope">
                            <el-button plain @click="handleSelect(scope.row)">选择</el-button>
                        </template>
                    </el-table-column>
                </el-table>
                <el-pagination v-model:current-page="currentPage" v-model:page-size="pageSize" :page-sizes="pageSizes"
                    :total="totalRows" background="background" layout="total, sizes, prev, pager, next, jumper"
                    @size-change="handleSizeChange" @current-change="handleCurrentChange">
                </el-pagination>
            </el-card>
        </el-dialog>
    </div>
</template>

<script setup>

import {
    ref,
    onMounted,
    watch,
    getCurrentInstance
} from 'vue'

const {
    proxy
} = getCurrentInstance()

import tools from '@/tools'

const cardBodyStyle = ref(tools.style.card)

const dialogVisible = ref(false)
const open = () => {
    dialogVisible.value = true
}
const close = () => {
    dialogVisible.value = false
}

const props = defineProps({
    column: { // form查询项
        type: Array,
        default: () => [
            {
                prop: 'purOrdSts',
                label: '订单状态',
                width: '120px',
            },
            {
                prop: 'purOrdNo',
                label: '订单号',
                width: '200px',
            },
            {
                prop: 'purOrdLn',
                label: '行号',
                width: '120px',
            },
            {
                prop: 'tradePartnerName',
                label: '供应商名称',
                width: '180px',
            },
            {
                prop: 'itemCd',
                label: '物料编码',
                width: '120px',
            },
            {
                prop: 'itemNm',
                label: '物料名称',
                width: '120px',
            },
            {
                prop: 'qty',
                label: '数量',
                width: '120px',
            },
            {
                prop: 'qtyUpper',
                label: '上允差(%)',
                width: '120px',
            },
            {
                prop: 'qtyLower',
                label: '下允差(%)',
                width: '120px',
            },
            {
                prop: 'uom',
                label: '计量单位',
                width: '120px',
            },
            {
                prop: 'taxPrice',
                label: '含税单价',
                width: '120px',
            },
            {
                prop: 'totalAmount',
                label: '含税金额',
                width: '120px',
            },
            {
                prop: 'price',
                label: '单价',
                width: '120px',
            },
            {
                prop: 'amount',
                label: '金额',
                width: '120px',
            },
            {
                prop: 'taxAmount',
                label: '税额',
                width: '120px',
            },
            {
                prop: 'taxRate',
                label: '税率',
                width: '120px',
            },
            {
                prop: 'delvDt',
                label: '交货日期',
                width: '120px',
            },

        ]
    },
    url: { // form查询数据
        type: String,
        default: 'pur/OrdLine/queryPopup'
    },
    purOrdNo: {
        type: String,
        required: true
    }
})
const query = ref({
    purOrdNo: '',
    purOrdLn: '',
})


/**
 *  查询字典
 */
const dicList = ref({
    PUR_ORD_STS: [],
    DELV_MTH: [],
    TMS_FTRANTYPE: [],
    SAL_INV_MTH: [],
    COM_PAY_MTH: [],
    MEASURING_UNIT: [],
    TAX_RATE: [],
})
const getDictList = () => {
    var url = 'framework/Common/querySelectorList'
    var param = {
        type: JSON.stringify(['PUR_ORD_STS', 'MEASURING_UNIT', 'TAX_RATE'])
    }
    proxy.$axios.get(url, param).then(response => {
        if (response.data.code == '0') {
            dicList.value = response.data.data
        } else {
            ElMessage.error('操作失败！' + response.data.msg)
        }
    })
}
const formatter = (row, column, cellValue, index) => {
    if (!cellValue || cellValue == null || cellValue == '') {
        return cellValue
    }
    switch (column.property) {
        case 'purOrdSts':
            cellValue = dicList.value.PUR_ORD_STS.find(item => item.dicCode == cellValue).dicName
            break
        case 'uom':
            cellValue = dicList.value.MEASURING_UNIT.find(item => item.dicCode == cellValue).dicName
            break
        case 'taxRate':
            cellValue = dicList.value.TAX_RATE.find(item => item.dicCode == cellValue).dicName
            break
    }

    return cellValue
}
/**
 *  查询字典
 */

const emit = defineEmits(['receiveFromChild'])
const handleSelect = (row) => {

    emit('receiveFromChild', row)
    close()
}
const currentPage = ref(1)
const pageSize = ref(10)
const pageSizes = ref([10, 20, 30, 40])
const tableData = ref([])
const totalRows = ref()
const initTableData = () => {
    tableData.value = []
    query.purOrdNo = props.purOrdNo

    var url = props.url
    var param = {
        page: currentPage.value,
        rows: pageSize.value,
        params: JSON.stringify(query.value)
    }

    proxy.$axios.get(url, param).then(response => {
        if (response.data.code == '0') {
            tableData.value = response.data.data.records
            totalRows.value = response.data.data.total
            console.log()
        } else {
            ElMessage.error('操作失败！' + response.data.msg)
        }
    })
}

const search = () => {
    initTableData()
}
const handleSizeChange = (val) => {
    pageSize.value = val
    initTableData()
}
const handleCurrentChange = (val) => {
    currentPage.value = val
    initTableData()
}

onMounted(() => {
    getDictList()
    initTableData()
})
watch(dialogVisible, (newValue, oldValue) => {
    if (newValue) {
        initTableData()
    } else {

    }
})
defineExpose({
    open,
    close
})
</script>

<style></style>